--
--Taunt Tattle Rehashed
--Author: Kasani - Agamaggan-US
--Original: CasualCorps
--
--Updated to 50001 to include more taunts, and add monk taunts
--Added announcing to party or raid, depending on which you're in
--
	versiontext = "v1.1.4b";
	prefixtext="[Taunt Tattle Rehashed]: ";
  if isEnabled == nil then
   isEnabled = true; -- This is the first time this addon is loaded; initialize the count to 0.
  end
  if isSelfOnly == nil then
   isSelfOnly = false; -- This is the first time this addon is loaded; initialize the count to 0.
  end
  if isIgnMT == nil then
   isIgnMT = false; -- This is the first time this addon is loaded; initialize the count to 0.
  end
  if isInGroup == nil then
   isInGroup = true; -- This is the first time this addon is loaded; initialize the count to 0.
  end
  if isAloneOn == nil then
   isAloneOn = false; -- This is the first time this addon is loaded; initialize the count to 0.
  end
  if isStanceOn == nil then
   isStanceOn = true; -- This is the first time this addon is loaded; initialize the count to 0.
  end
  
  if WhisperNonTank == nil then
   WhisperNonTank = true;
  end
  
  if optionalspells == nil then
   optionalspells = {}; -- This is the first time this addon is loaded; initialize the count to 0.
  end
  
  if ignoredplayersvars == nil then
	ignoredplayersvars = true;
  end
  
  if ignoredplayers == nil then
   ignoredplayers = {}; -- This is the first time this addon is loaded; initialize the count to 0.
  end
  
  if ignoredplayersvars == true then
	wipe(ignoredplayers);
  end
  
  
  
  
  SpellsTauntCS = {	--Cast Success
		-- Warrior
		355,	--Taunt
		114192,	--Mocking Banner
		-- Paladin
		31789,	--Righteous Defense
		62124,	--Reckoning
		-- Druid
		6795,	--Growl
		-- Death Knight
		-- 49576,	--Death Grip (Pull)
		56222,	--Dark Command
		-- Monk
		115546,	--Provoke
		--115180,	--Dizzying Haze
		--121253,	--Optional: Keg Smash
		-- Warlock
		97827,	--Provocation
		17735,	--Pet - Suffering (Voidwalker/Voidlord)
		-- Shaman
		73684,	--Unleash Elements - Rockbiter
		-- Hunter
		20736,	--Distracting Shot
		2649,	--Pet - Growl
			
		
		-- Legacy or Unknown
		5209,	
		1161,	
		694		
		};
  
  SpellsTauntAA = {	--Aura Applies
		-- Death Knight
		49560,	--Death Grip (Taunt)
		51399	--Death Grip (Taunt) 
		};
  
  SpellsStanceCS = {--Cast Success
			--Shaman
		8017 --Rockbiter
		};
  
  SpellsStanceAA = {--Aura Applies
		--Warrior
		71,		--Defensive stance
		--Paladin
		25780,	--Righteous Fury
		--Druid
		5487,	--Bear Form
		--Death Knight
		48263,	--Blood Presence
		--42650,	--Army of the Dead
		--Monk
		115069,	--Stance of the Sturdy Ox
		--Shaman
		--2062,	--Earth Elemental Totem
		--Warlock
		114168,	--Dark Apotheosis 
		112042,	--Pet - Threatening Presence (Voidwalker/Voidlord)
		134477	--Pet - Threatening Presence (Felguard/Wrathguard)
		};
  
  
  
local scanTool = CreateFrame( "GameTooltip", "ScanTooltip", nil, "GameTooltipTemplate" );
scanTool:SetOwner( WorldFrame, "ANCHOR_NONE" );
local scanText = _G["ScanTooltipTextLeft2"]; -- This is the line with <[Player]'s Pet>
function getPetOwner(petName)
   scanTool:ClearLines()
   scanTool:SetUnit(petName)
   local ownerText = scanText:GetText()
   if not ownerText then return nil end
   local owner, _ = string.split("'",ownerText)
   
   if(string.find(ownerText, "'s Pet") or string.find(ownerText, "'s Minion")) then
		return owner
	else
		return nil
   end
   
   --return owner -- This is the pet's owner
end
  

  SLASH_TTR1 = '/ttr'; -- 3.
function SlashCmdList.TTR(msg, editbox) -- 4.
	if (isEnabled == nil or isEnabled == true) then
		isEnabledText = "On";
		else
		isEnabledText = "Off";
	end
	if (isSelfOnly == nil or isSelfOnly == false) then
		isSelfOnlyText = "Off";
		else
		isSelfOnlyText = "On";
	end
	if (isIgnMT == nil or isIgnMT == false) then
		isIgnMTText = "Off";
		else
		isIgnMTText = "On";
	end
	if (isInGroup == nil or isInGroup == true) then
		isInGroupText = "On";
		else
		isInGroupText = "Off";
	end
	if (isAloneOn == nil or isAloneOn == false) then
		isAloneOnText = "Off";
		else
		isAloneOnText = "On";
	end
	if (isStanceOn == nil or isStanceOn == true) then
		isStanceOnText = "On";
		else
		isStanceOnText = "Off";
	end
	if (WhisperNonTank == nil or WhisperNonTank == false) then
		WhisperNonTankText = "Off";
		else
		WhisperNonTankText = "On";
	end
	--if ( == nil or 
	--ignoredplayersvars
	
	--print(msg);
if (msg == nil or msg == "" or msg == "options") then
	TauntTattleOptionsFrame_Show();
elseif (msg == "help" or msg == "?") then
	print("[Taunt Tattle Rehashed] "..versiontext.." by Kasani - Agamaggan-US\n  Option Commands are listed below\n  Toggle Announcements ("..isEnabledText.."): /ttr toggle (/ttr tg)\n  Toggle Self Only Mode ("..isSelfOnlyText.."): /ttr selfonly (/ttr so)\n  Toggle Ignore Main Tank Mode ("..isIgnMTText.."): /ttr ignoremt (/ttr imt)\n  Toggle In Party Mode ("..isInGroupText.."): /ttr inparty (/ttr ip)\n  Toggle Alone Mode ("..isAloneOnText.."): /ttr alone (/ttr al)\n  Toggle Stance Mode ("..isStanceOnText.."): /ttr stance (/ttr st)\n  Toggle Whisper NonTank ("..WhisperNonTankText.."): /ttr whisper (/ttr wnt)");
elseif (msg == "toggle" or msg == "tg") then
	if(isEnabled == false) then
		isEnabled = true;
		print("[Taunt Tattle Rehashed] is now Enabled.");
	else
		isEnabled = false;
		print("[Taunt Tattle Rehashed] is now Disabled.");
	end
	
	
elseif (msg == "self only" or msg == "selfonly" or msg == "so") then
	if(isSelfOnly == false) then
		isSelfOnly = true;
		print("[Taunt Tattle Rehashed] Announcements will now only send to you.");
	else
		isSelfOnly = false;
		print("[Taunt Tattle Rehashed] Announcements will now send to party or raid.");
	end
	
	
elseif (msg == "ignore main tank" or msg == "ignore mt" or msg == "ignoremaintank" or msg == "ignoremt" or msg == "imt") then
	if(isIgnMT == false) then
		isIgnMT = true;
		print("[Taunt Tattle Rehashed] Announcements will now ignore players marked as 'Tank'.");
	else
		isIgnMT = false;
		print("[Taunt Tattle Rehashed] Announcements will now send all taunts.");
	end
	
	
elseif (msg == "in party" or msg == "inparty" or msg == "ip") then
	if(isInGroup == false) then
		isInGroup = true;
		print("[Taunt Tattle Rehashed] Announcements will now check if source is in party or raid.");
	else
		isInGroup = false;
		print("[Taunt Tattle Rehashed] Announcements will now include all sources.");
	end
	
	
elseif (msg == "alone" or msg == "al") then
	if(isAloneOn == false) then
		isAloneOn = true;
		print("[Taunt Tattle Rehashed] Announcements will now tattle if you are alone (not in group/raid).");
	else
		isAloneOn = false;
		print("[Taunt Tattle Rehashed] Announcements will not tattle if you are alone (not in group/raid).");
	end
	
	
elseif (msg == "stance" or msg == "st") then
	if(isStanceOn == false) then
		isStanceOn = true;
		print("[Taunt Tattle Rehashed] Announcements will now scan for Stance changes.");
	else
		isStanceOn = false;
		print("[Taunt Tattle Rehashed] Announcements will now ignore stances.");
	end
	
	
elseif (msg == "whisper" or msg == "wnt") then
	if(WhisperNonTank == false) then
		WhisperNonTank = true;
		print("[Taunt Tattle Rehashed] will now whisper players not flagged as tank (Only for players in party/raid).");
	else
		WhisperNonTank = false;
		print("[Taunt Tattle Rehashed] will not whisper anyone.");
	end

elseif (msg == "ignore" or msg == "ig") then
	IgnorePlayerToggle();
	
elseif (msg == "ignorelist" or msg == "iglist") then
	ListIgnoredPlayers();
elseif (msg == "ignorereset" or msg == "igre") then
	ResetIgnoredPlayers();
elseif (msg == "ignoreautoreset" or msg == "igar") then
	if(ignoredplayersvars == false) then
		ignoredplayersvars = true;
		print("[Taunt Tattle Rehashed] Ignored players will be cleared on new session.");
	else
		ignoredplayersvars = false;
		print("[Taunt Tattle Rehashed] Ignored players will save between sessions.");
	end
--elseif (msg == "lfg") then
	-- if (GetLFGMode() == nil) then
		-- print("[Taunt Tattle Rehashed] NOLFG");
	-- else 
		-- print("[Taunt Tattle Rehashed] "..GetLFGMode());
	-- end
	--if(IsInInstance()) then
		--print("[Taunt Tattle Rehashed] "..IsInInstance());
	--end
	-- GetLFGMode()
		-- print("[Taunt Tattle Rehashed] INSTANCE_CHAT");
	-- else
		-- print("[Taunt Tattle Rehashed] RAID");
	-- end
end

end

function TauntTattleFrame_OnLoad()

-- TTRAddon = {};
-- TTRAddon.panel = CreateFrame( "Frame", "TTRAddon", UIParent );
 -- Register in the Interface Addon Options GUI
 -- Set the name for the Category for the Options Panel
-- TTRAddon.panel.name = "Taunt Tattle Rehashed";
 -- Add the panel to the Interface Options
 --TTRAddon.name = "Taunt Tattle Rehashed";
-- InterfaceOptions_AddCategory(TTRAddon.panel);

	TauntTattleFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");


	ChatFrame1:AddMessage("|cffffff00 Taunt Tattle Rehashed Loaded. Type /ttr for options.");
	

	-- already hidden by default, but just in case...
	TauntTattleFrame:Hide();
end


function TauntTattleFrame_OnEvent(event, ...)
if (isEnabled == true) then
	local timestamp, ttype, hideCaster, srcGUID, srcName, srcFlags, sourceRaidFlags, dstGUID, dstName, dstFlags, destRaidFlags, spellid, spellname, spellschool, targetchan, isGo, OKTOCcontinue, b_or_d = select(1, ...);
	
	ingroup = IsInGroup();
if((ingroup == false) and (isAloneOn == false)) then
else

	--if (UnitIsUnit("partypet1", srcName) or UnitIsUnit("raidpet1", srcName)) then
	--if ( UnitIsUnit(srcName, "pet")) then
	--if ( UnitPlayerOrPetInRaid(srcName) or UnitPlayerOrPetInParty(srcName) ) then

		
	--ChatFrame1:AddMessage("Spell Detected: "..srcName.." -> "..spellid.." -> "..spellname);
	--<TAUNT SECTION>--
	if ((ttype == "SPELL_CAST_SUCCESS") and (inTable(SpellsTauntCS, spellid))) or ((ttype == "SPELL_AURA_APPLIED") and (inTable(SpellsTauntAA, spellid))) or ((ttype == "SPELL_CAST_SUCCESS") and (inTable(optionalspells, spellid))) then
	--ChatFrame1:AddMessage("Spell Confirmed: "..srcName.." -> "..spellid.." -> "..spellname.." -> "..dstName);


	OKTOCcontinue = true;
	
	--if spellid == 121253 and optionalspells[1] == false then
	--	OKTOCcontinue = false;
	--end
	
	if(OKTOCcontinue == true) then
	
	isGo = false;
	if ( isSelfOnly == false ) then
		if ( IsInRaid() == true ) then
			--targetchan = "RAID";
			targetchan = "RAID";
			isGo = true;
			inParty = UnitPlayerOrPetInRaid(srcName);
		elseif ( IsInGroup() == true ) then
			targetchan = "PARTY";
			isGo = true;
			inParty = UnitPlayerOrPetInParty(srcName);
		end
		if(IsInGroup(LE_PARTY_CATEGORY_INSTANCE)) then
			targetchan = "INSTANCE_CHAT";
		end
	else 
		if ( IsInRaid() == true ) then
			isGo = false;
			inParty = UnitPlayerOrPetInRaid(srcName);
		elseif ( IsInGroup() == true ) then
			isGo = false;
			inParty = UnitPlayerOrPetInParty(srcName);
		end
	end
	
	--ChatFrame1:AddMessage("isGo is "..isGo.." - "..GetNumGroupMembers());

	--isAssigned = GetPartyAssignment("TANK");
	isAssigned = UnitGroupRolesAssigned(srcName);
	--print(srcName.." - "..inParty);
	
	if ( isAssigned == "TANK" and isIgnMT == true ) then
		--print("    IGNORED");
	
	elseif (isInGroup == true and inParty == nil) then
		--print("    IGNORED IP");
	
	elseif (inTable(ignoredplayers, srcName)) then
		--print("    IGNORED IG");
	
	else
		if (isGo == true) then
			if (dstName) then
				if (getPetOwner(srcName) ~= nil) and (UnitIsUnit(getPetOwner(srcName), "player") == nil) then
					SendChatMessage(prefixtext..spellname.." used to taunt "..dstName.." by ".. srcName.." ("..getPetOwner(srcName)..")", targetchan);
				else
					SendChatMessage(prefixtext..spellname.." used to taunt "..dstName.." by ".. srcName, targetchan);
				end
			else
				if (getPetOwner(srcName) ~= nil) and (UnitIsUnit(getPetOwner(srcName), "player") == nil) then
					SendChatMessage(prefixtext..spellname.." used by ".. srcName.." ("..getPetOwner(srcName)..")", targetchan);
				else
					SendChatMessage(prefixtext..spellname.." used by ".. srcName, targetchan);
				end
			end
		else
			if (dstName) then
				ChatFrame1:AddMessage(prefixtext..spellname.." used to taunt "..dstName.." by ".. srcName);
			else
				ChatFrame1:AddMessage(prefixtext..spellname.." used by ".. srcName);
			end
		end
		if ( isAssigned ~= "TANK" ) and ( WhisperNonTank == true ) and ( inParty == 1 ) and ( isSelfOnly == false ) and (UnitIsUnit(srcName, "player") == nil) then
			if (getPetOwner(srcName) ~= nil) and (UnitIsUnit(getPetOwner(srcName), "player") == nil) then
				--print("Source Name: "..srcName..", Pet Owner: "..getPetOwner(srcName));
				SendChatMessage(prefixtext.." Your pet ("..srcName..") is taunting, please disable "..spellname..".", "WHISPER", nil, getPetOwner(srcName));
			else
				SendChatMessage(prefixtext.." You are not the tank. Please do not use "..spellname, "WHISPER", nil, srcName);
			end
		end
	end

	end
	end
	--<TAUNT SECTION>--
	--<STANCE SECTION>--
	if ((ttype == "SPELL_CAST_SUCCESS") and (inTable(SpellsStanceCS, spellid))) or ((ttype == "SPELL_AURA_APPLIED") and (inTable(SpellsStanceAA, spellid))) then

	
	
	isGo = false;
	if ( isSelfOnly == false ) then
		if ( IsInRaid() == true ) then
			targetchan = "RAID";
			isGo = true;
			inParty = UnitPlayerOrPetInRaid(srcName);
		elseif ( IsInGroup() == true ) then
			targetchan = "PARTY";
			isGo = true;
			inParty = UnitPlayerOrPetInParty(srcName);
		end
		if(IsInGroup(LE_PARTY_CATEGORY_INSTANCE)) then
			targetchan = "INSTANCE_CHAT";
		end
	else 
		if ( IsInRaid() == true ) then
			isGo = false;
			inParty = UnitPlayerOrPetInRaid(srcName);
		elseif ( IsInGroup() == true ) then
			isGo = false;
			inParty = UnitPlayerOrPetInParty(srcName);
		end
	end
	isAssigned = UnitGroupRolesAssigned(srcName);
	
		--ChatFrame1:AddMessage("Spell Confirmed: "..srcName.." -> "..spellid.." -> "..spellname);
	if ( isAssigned == "TANK" and isIgnMT == true ) then
		--print("    IGNORED");
	
	elseif (isInGroup == true and inParty == nil) then
		--print("    IGNORED IP");
	
	elseif (inTable(ignoredplayers, srcName)) then
		--print("    IGNORED IG");
	
	else
		if (isGo == true) then
			SendChatMessage(prefixtext..srcName.." has enabled "..spellname, targetchan);
		else
			ChatFrame1:AddMessage(prefixtext..srcName.." has enabled "..spellname);
		end
		if ( isAssigned ~= "TANK" ) and ( WhisperNonTank == true ) and ( inParty == 1 ) and ( isSelfOnly == false ) and (UnitIsUnit(srcName, "player") == nil) then
			if (getPetOwner(srcName) ~= nil) and (UnitIsUnit(getPetOwner(srcName), "player") == nil) then
				--print("Source Name: "..srcName..", Pet Owner: "..getPetOwner(srcName));
				SendChatMessage(prefixtext.." Your pet ("..srcName..") is taunting, please disable "..spellname..".", "WHISPER", nil, getPetOwner(srcName));
			else
				SendChatMessage(prefixtext.." You are not the tank. Please do not use "..spellname, "WHISPER", nil, srcName);
			end
		end
	end

	
	end
	--<STANCE SECTION>--
end
end

end


function inTable(tbl, item)
    for key, value in pairs(tbl) do
        if value == item then return key end
    end
    return false
end

function inTableList(tbl)
	List = "";
    for key, value in pairs(tbl) do
        List = List..value..", ";
    end
    return List
end




function DetectInstanceChange()
	print("Instance Change!");
end



function IgnorePlayerToggle()
	if(UnitName("target")) then
		local targetname = UnitName("target");
		if(inTable(ignoredplayers, targetname)) then
			tremove(ignoredplayers, inTable(ignoredplayers, targetname));
			print("[Taunt Tattle Rehashed] Will no longer ignore "..targetname);
		else
			tinsert(ignoredplayers, targetname);
			print("[Taunt Tattle Rehashed] Will now ignore "..targetname);
		end
	else
		print("[Taunt Tattle Rehashed] Please target someone to ignore.");
	end
end

function ListIgnoredPlayers()
	print("[Taunt Tattle Rehashed] Players in ignore list:\n"..inTableList(ignoredplayers));
end

function ResetIgnoredPlayers()
	ignoredplayers = {};
	print("[Taunt Tattle Rehashed] Ignored players cleared");
end






function TauntTattleOptionsFrame_OnLoad(TTRAddon)
--TTRAddon = {};
	TTRAddon.name = GetAddOnMetadata("TauntTattleRehashed", "Title")
	TTRAddon.okay = TauntTattleOptionsFrame_Save
	TTRAddon.cancel = TauntTattleOptionsFrame_Cancel
	TTRAddon.default = TauntTattleOptionsFrame_SetDefaultOptions
	InterfaceOptions_AddCategory(TTRAddon)
end
function TauntTattleOptionsFrame_Show()
	InterfaceOptionsFrame_OpenToCategory(TTRAddon);
end
function TauntTattleOptionsFrame_OnShow()
	Header2:SetText("Version "..versiontext);

	ckbEnabled:SetChecked(isEnabled);
	chkSOMode:SetChecked(isSelfOnly);
	ckbIMTMode:SetChecked(isIgnMT);
	ckbIPMode:SetChecked(isInGroup);
	ckbALMode:SetChecked(isAloneOn);
	ckbSTMode:SetChecked(isStanceOn);
	ckbWNTMode:SetChecked(WhisperNonTank);
	ckbIGARMode:SetChecked(ignoredplayersvars);
	--if(inTable(optionalspells, 115180))
	--	ckbOpSp115180:SetChecked(true);
	--else
	--	ckbOpSp115180:SetChecked(false);
	--end
	CancelOptions = { }
	CancelOptions.isEnabled = isEnabled
	CancelOptions.isSelfOnly = isSelfOnly
	CancelOptions.isIgnMT = isIgnMT
	CancelOptions.isInGroup = isInGroup
	CancelOptions.isAloneOn = isAloneOn
	CancelOptions.isStanceOn = isStanceOn
	CancelOptions.WhisperNonTank = WhisperNonTank
	CancelOptions.ignoredplayersvars = ignoredplayersvars
		--CancelOptions.ckbOpSp115180 = ckbOpSp115180:GetChecked()
end


function TauntTattleOptionsFrame_Save()
	--print("ttr Save");
end
function TauntTattleOptionsFrame_OnHide()
	--print("ttr Save");
	CancelOptions = nil
end
function TauntTattleOptionsFrame_Cancel()
	--print("ttr Cancel");
	if CancelOptions then
	isEnabled = CancelOptions.isEnabled;
	isSelfOnly = CancelOptions.isSelfOnly;
	isIgnMT = CancelOptions.isIgnMT;
	isInGroup = CancelOptions.isInGroup;
	isAloneOn = CancelOptions.isAloneOn;
	isStanceOn = CancelOptions.isStanceOn;
	WhisperNonTank = CancelOptions.WhisperNonTank;
		--optionalspells[1] = CancelOptions.ckbOpSp115180;
	end
end


function TauntTattleOptionsFrame_SetDefaultOptions()
	--print("ttr Default");
end

function TauntTattleOptionsFrame_CBEnable(f)
	--if (ckbEnabled:GetChecked()) then
	if (f) then
	isEnabled = true;
	else
	isEnabled = false;
	end
end

function TauntTattleOptionsFrame_CBSOMode(f)
	--if (ckbEnabled:GetChecked()) then
	if (f) then
	isSelfOnly = true;
	else
	isSelfOnly = false;
	end
end

function TauntTattleOptionsFrame_CBIMTMode(f)
	--if (ckbEnabled:GetChecked()) then
	if (f) then
	isIgnMT = true;
	else
	isIgnMT = false;
	end
end

function TauntTattleOptionsFrame_CBIPMode(f)
	--if (ckbEnabled:GetChecked()) then
	if (f) then
	isInGroup = true;
	else
	isInGroup = false;
	end
end

function TauntTattleOptionsFrame_CBALMode(f)
	--if (ckbEnabled:GetChecked()) then
	if (f) then
	isAloneOn = true;
	else
	isAloneOn = false;
	end
end

function TauntTattleOptionsFrame_CBSTMode(f)
	--if (ckbEnabled:GetChecked()) then
	if (f) then
	isStanceOn = true;
	else
	isStanceOn = false;
	end
end

function TauntTattleOptionsFrame_CBWNTMode(f)
	--if (ckbEnabled:GetChecked()) then
	if (f) then
	WhisperNonTank = true;
	else
	WhisperNonTank = false;
	end
end

function TauntTattleOptionsFrame_CBIGARMode(f)
	--if (ckbEnabled:GetChecked()) then
	if (f) then
	ignoredplayersvars = true;
	else
	ignoredplayersvars = false;
	end
end

function TauntTattleOptionsFrame_OptionalSpells(spell, f)
	--if (ckbEnabled:GetChecked()) then
	if (f) then
	optionalspells[spell] = true;
	else
	optionalspells[spell] = false;
	end
end